/* REXX Exec to display the City and time zone for a given areacode */
Arg areacode .
If areacode = '?' Then Signal Explain
If areacode = ''
Then Do
     Say 'Enter Areacode:'
     Pull areacode .
     End
/* Set up area codes */
Call INIT
If state.areacode = ''
Then Say 'Areacode' areacode 'not found.'
Else Do
     Say 'Areacode  ==>' areacode
     Say 'State     ==>' state.areacode
     Say 'Time Zone ==>' zone.areacode
     End
Return
/* ------------------------------------------------------------------ */
Explain:
Say 'The AREACODE exec is used to get the location (state)'
Say 'and time zone of a given area code.'
Say ''
Say 'The time zones indicated are:'
Say '======================================='
Say 'Hawaii   (Pacific time -3 hours)'
Say 'Alaska   (Pacific time -1 hour)'
Say 'Pacific'
Say 'Mountain (Pacific time +1 hour)'
Say 'Central  (Pacific time +2 hours)'
Say 'Eastern  (Pacific time +3 hours)'
Say 'Atlantic (Pacific time +4 hours)'
Return
/* ------------------------------------------------------------------ */
Init:
State.='';                             Zone. = ''
State.201='New Jersey';                Zone.201='Eastern'
State.202='Washington DC';             Zone.202='Eastern'
State.203='Connecticut';               Zone.203='Eastern'
State.204='Manitoba, Canada';          Zone.204='Central'
State.205='Alabama';                   Zone.205='Central'
State.206='Washington';                Zone.206='Pacific'
State.207='Main';                      Zone.207='Eastern'
State.208='Idaho';                     Zone.208='Mountain'
State.209='California';                Zone.209='Pacific'
State.210='Texas';                     Zone.210='Central'
State.212='New York';                  Zone.212='Eastern'
State.213='California';                Zone.213='Pacific'
State.214='Texas';                     Zone.214='Central'
State.215='Pennsylvania';              Zone.215='Eastern'
State.216='Ohio';                      Zone.216='Eastern'
State.217='Illinois';                  Zone.217='Central'
State.218='Maryland';                  Zone.218='Eastern'
State.219='Indiana';                   Zone.219='Eastern'
State.301='Marland';                   Zone.301='Eastern'
State.302='Delaware';                  Zone.302='Eastern'
State.303='Colorado';                  Zone.303='Mountain'
State.304='West Virginia';             Zone.304='Eastern'
State.305='Florida';                   Zone.305='Eastern'
State.306='Saskatchewan, Canada';      Zone.306='Mountain'
State.307='Wyoming';                   Zone.307='Mountain'
State.308='Nebraska';                  Zone.308='Mountain'
State.309='Illinois';                  Zone.309='Central'
State.310='California';                Zone.310='Pacific'
State.312='Illinois';                  Zone.312='Central'
State.313='Michigan';                  Zone.313='Eastern'
State.314='Missouri';                  Zone.314='Central'
State.315='New York';                  Zone.315='Eastern'
State.316='Kansas';                    Zone.316='Central'
State.317='Indiana';                   Zone.317='Eastern'
State.318='Louisiana';                 Zone.318='Central'
State.319='Iowa';                      Zone.319='Central'
State.401='Rhode Island';              Zone.401='Eastern'
State.402='Nebraska';                  Zone.402='Central'
State.403='Alberta, Canada';           Zone.403='Mountain'
State.404='Georgia';                   Zone.404='Eastern'
State.405='Oklahoma';                  Zone.405='Central'
State.406='Montana';                   Zone.406='Mountain'
State.407='Florida';                   Zone.407='Eastern'
State.408='California';                Zone.408='Pacific'
State.409='Texas';                     Zone.409='Central'
State.410='Maryland';                  Zone.410='Eastern'
State.412='Pennsylvania';              Zone.412='Eastern'
State.413='Massachusetts';             Zone.413='Eastern'
State.414='Wisconsin';                 Zone.414='Central'
State.415='California';                Zone.415='Pacific'
State.416='Ontario, Canada (Toronto)'; Zone.416='Eastern'
State.417='Missouri';                  Zone.417='Central'
State.418='Quebec, Canada';            Zone.418='Eastern'
State.419='Ohio';                      Zone.419='Eastern'
State.501='Arkansas';                  Zone.501='Central'
State.502='Kentucky';                  Zone.502='Central'
State.503='Oregon';                    Zone.503='Pacific'
State.504='Louisiana';                 Zone.504='Central'
State.505='New Mexico';                Zone.505='Mountain'
State.506='New Brunswick';             Zone.506='Atlantic'
State.507='Minnesota';                 Zone.507='Central'
State.508='Massachusetts';             Zone.508='Eastern'
State.509='Washington';                Zone.509='Pacific'
State.510='California';                Zone.510='Pacific'
State.512='Texas';                     Zone.512='Central'
State.513='Ohio';                      Zone.513='Eastern'
State.514='Quebec, Canada (Montreal)'; Zone.514='Eastern'
State.515='Iowa';                      Zone.515='Central'
State.516='New York';                  Zone.516='Eastern'
State.517='Michigan';                  Zone.517='Eastern'
State.518='New York';                  Zone.518='Eastern'
State.519='Ontario, Canada';           Zone.519='Eastern'
State.601='Mississippi';               Zone.601='Central'
State.602='Arizona';                   Zone.602='Mountain'
State.603='New Hampshire';             Zone.603='Eastern'
State.604='British Columbia, Canada';  Zone.604='Pacific'
State.605='South Dakota';              Zone.605='Central'
State.606='Kentucky';                  Zone.606='Eastern'
State.607='New York';                  Zone.607='Eastern'
State.608='Wisconsin';                 Zone.608='Central'
State.609='New Jersey';                Zone.609='Eastern'
State.612='Minnesota';                 Zone.612='Central'
State.613='Ontario, Canada (Ottawa)';  Zone.613='Eastern'
State.614='Ohio';                      Zone.614='Eastern'
State.615='Tennessee';                 Zone.615='Central'
State.616='Michigan';                  Zone.616='Eastern'
State.617='Massachusetts';             Zone.617='Eastern'
State.618='Illinois';                  Zone.618='Central'
State.619='California';                Zone.619='Pacific'
State.701='North Dakota';              Zone.701='Central'
State.702='Nevada';                    Zone.702='Pacific'
State.703='Virginia';                  Zone.703='Eastern'
State.704='North Carolina';            Zone.704='Eastern'
State.705='Ontario, Canada';           Zone.705='Eastern'
State.706='Georgia';                   Zone.706='Eastern'
State.707='California';                Zone.707='Pacific'
State.708='Illinois';                  Zone.708='Central'
State.709='Newfoundland';              Zone.709='Atlantic'
State.712='Iowa';                      Zone.712='Central'
State.713='Texas';                     Zone.713='Central'
State.714='California';                Zone.714='Pacific'
State.715='Wisconsin';                 Zone.715='Central'
State.716='New York';                  Zone.716='Eastern'
State.717='Pennsylvania';              Zone.717='Eastern'
State.718='New York';                  Zone.718='Eastern'
State.719='Colorado';                  Zone.719='Mountain'
State.801='Utah';                      Zone.801='Mountain'
State.802='Vermont';                   Zone.802='Eastern'
State.803='South Carolina';            Zone.803='Eastern'
State.804='Virginia';                  Zone.804='Eastern'
State.805='California';                Zone.805='Pacific'
State.806='Texas';                     Zone.806='Central'
State.807='Ontario, Canada';           Zone.807='Eastern'
State.808='Hawaii';                    Zone.808='Hawaii'
State.809='Puerto Rico/Caribbean Islands'; Zone.809='??'
State.812='Indiana';                   Zone.812='Eastern'
State.813='Florida';                   Zone.813='Eastern'
State.814='Pennsylvania';              Zone.814='Eastern'
State.815='Illinois';                  Zone.815='Central'
State.816='Missouri';                  Zone.816='Central'
State.817='Texas';                     Zone.817='Central'
State.818='California';                Zone.818='Pacific'
State.819='Quebec, Canada';            Zone.819='Eastern'
State.901='Tennessee';                 Zone.901='Central'
State.902='Nova Scotia/Prince Edward Is.';  Zone.902='Atlantic'
State.903='Texas';                     Zone.903='Central'
State.904='Florida';                   Zone.904='Eastern'
State.906='Michigan';                  Zone.906='Eastern'
State.907='Alaska';                    Zone.907='Alaska'
State.908='New Jersey';                Zone.908='Eastern'
State.909='California';                Zone.909='Pacific'
State.912='Georgia';                   Zone.912='Eastern'
State.913='Kansas';                    Zone.913='Central'
State.914='New York';                  Zone.914='Eastern'
State.915='Texas';                     Zone.915='Central'
State.916='California';                Zone.916='Pacific'
State.918='Oklahoma';                  Zone.918='Central'
State.919='North Carolina';            Zone.919='Eastern'
Return
