/* REXX exec to convert decimal numbers to roman numeral notation */
Arg decimal .

If decimal = '?' Then Signal Explain
If decimal = ''
Then Do
     Say 'Enter A Decimal Number:'
     Pull decimal .
     End
If datatype(decimal,W) = 1 Then Signal Explain

/* Temporary patch to avoid errors from too large of decimal numbers */
If decimal > 3999
Then Do
     Say 'The largest decimal number currently supported is 3999.'
     Return
     End

roman = ''                   /* initialize the result to null */
declen = length(decimal)     /* get length of decimal number */

Do i = 1 to declen           /* start of calculation loop */
   d = substr(decimal,i,1)   /* get next "place" in decimal # */
   If d = 0 Then iterate     /* skip over 0s */
                             /* Get roman number for this digit */
   r = word('I II III IV V VI VII VIII IX ',d)
   Do declen - i           /* Multiply by appropriate factor of 10 */
      r = translate(r,'XLCDM**','IVXLCDM')
   End
   roman = roman||r
End                          /* end of calculation loop */

Say decimal '(Decimal) ==>' roman '(Roman)'
Exit
/* --------------------------------------------------------------- */
Explain:
Say 'This program will take a decimal (whole) number and display '
Say 'the equivalent roman numeral.'
Say ' '
Say 'For example, use: "d2r 1024" to find the roman number'
Say 'symbology for the decimal number "1024".'
Return
