/* REXX exec to convert a roman numeral notation to decimal numbers */
Arg roman .

If roman = '?' Then Signal Explain
If roman = ''
Then Do
     Say 'Enter A Roman Numeral:'
     Pull roman .
     End

decimal = 0                  /* initialize decimal value (result) to 0 */
lastd = 0                    /* lastd holds the previous d value */

/* The following are rexx "stem" variables that work like */
/* associative arrays (using a non-numeric index value) */
dec. = 0           /* set un-specified values to 0 */
dec.I = 1
dec.V = 5
dec.X = 10
dec.L = 50
dec.C = 100
dec.D = 500
dec.M = 1000

romlen = length(roman)
Do i = romlen to 1 by -1     /* start of calculation loop */
   r = substr(roman,i,1)     /* begin at end of roman numeral */
   d = dec.r                 /* get decimal value for this char */
   If d = 0                  /* Check for invalid characters */
   Then Do
        Say 'Invalid Character "'r'". Please try again.'
        Return
        End
   If d < lastd                /* compare d to previous character ... */
   Then decimal = decimal - d  /* if less, then subtract value */
   Else decimal = decimal + d  /* if greater, then add value */
lastd = d
End                          /* end of calculation loop */

Say roman '(Roman) ==>' decimal '(Decimal)'
Exit
/* --------------------------------------------------------------- */
Explain:
Say 'This program will take a roman numeral and display the'
Say 'equivalent decimal number.'
Say ' '
Say 'For example, use: "r2d mxxiv" to find the decimal number'
Say 'for the roman numeral "mxxiv".'
Return
